=== debian/changelog ===
wesnoth-1.16 (1:1.16.11-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:34:43 +1100

wesnoth-1.16 (1:1.16.11-1build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:51:34 +0000

wesnoth-1.16 (1:1.16.11-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 02:15:12 +0000

wesnoth-1.16 (1:1.16.11-1) unstable; urgency=medium

  * New upstream release.
    - Fix FTBFS with boost 1.83. (Closes: #1055973)

 -- Vincent Cheng <vcheng@debian.org>  Sat, 30 Dec 2023 01:18:06 -0800

wesnoth-1.16 (1:1.16.10-2) unstable; urgency=medium

  * Fix FTBFS when building with dpkg-buildpackage -B/-A.

 -- Vincent Cheng <vcheng@debian.org>  Mon, 07 Aug 2023 22:43:59 -0700

wesnoth-1.16 (1:1.16.10-1) unstable; urgency=medium

  * New upstream release.
    - Drop debian/patches/04gcc13-ftbfs; applied upstream.
  * Modernize debian/rules using short-hand dh.

 -- Vincent Cheng <vcheng@debian.org>  Mon, 07 Aug 2023 13:24:06 -0700

wesnoth-1.16 (1:1.16.9-2) unstable; urgency=medium

  * Add upstream patch to fix FTBFS with gcc 13. (Closes: #1037895)

 -- Vincent Cheng <vcheng@debian.org>  Sat, 15 Jul 2023 23:41:15 -0700
