=== debian/tests/control ===
# Inspired by upstream CI script utils/CI/play_test_executor.sh
# This runs wesnoth with a multiplayer AI-only matchup.
Test-Command: /usr/games/wesnoth-1.16 -m --controller 1:ai --controller 2:ai --nogui
Depends:
 wesnoth-1.16,
 xauth,
 xvfb
Restrictions: allow-stderr
